//
//  LUA_to_TNSAppDelegate.m
//  LUA to TNS
//
//  Made by Adrien Bertrand on Sept 5th 2011.
//  Copyright 2011 Adriweb. All rights reserved.
//

#import "LUA_to_TNSAppDelegate.h"

@implementation LUA_to_TNSAppDelegate

@synthesize window, image, outputTitle, theButton, theCommand, finalPath;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateSource:) name:@"updateSource" object:theSource];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(changeON) name:@"goChange" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(changeOFF) name:@"goChange2" object:nil];
    [self changeOFF];
    [self setTheName:@"MyProgram.tns"];
}

- (void)changeON{
    [image setImage:[NSImage imageNamed:@"iconON.png"]];
    [theButton setEnabled:YES];
}

- (void)changeOFF{
    [image setImage:[NSImage imageNamed:@"iconOFF.png"]];
    [theButton setEnabled:NO];
}

- (void)setTheName:(NSString *)theTitle {
    [outputTitle setStringValue:theTitle];
    [outputTitle setStringValue:[[outputTitle stringValue] stringByReplacingOccurrencesOfString:@".lua" withString:@".tns"]];
    if (![[outputTitle stringValue] hasSuffix:@".tns"]) {
        // that should never happen though....
        [outputTitle setStringValue:[[outputTitle stringValue] stringByAppendingString:@".tns"]];
    }
}

- (void)newName {
    finalPath = [[NSMutableString alloc] initWithFormat:theSource];
    [finalPath deleteCharactersInRange: [finalPath rangeOfString: [outputTitle stringValue]]];
}

- (void)updateSource:(NSNotification *)pNotification {
    theSource = [(NSString*)[pNotification object] stringByReplacingOccurrencesOfString:@"file://localhost" withString:@""];
    theSource = [theSource stringByReplacingOccurrencesOfString:@"%20" withString:@"\\ "];
    [outputTitle setStringValue:[[theSource lastPathComponent] stringByReplacingOccurrencesOfString:@"\\ " withString:@" "]];
    [self newName];
    [self setTheName:[outputTitle stringValue]];
    theCommand = [[NSString alloc] initWithFormat:@"\"%@\" \"%@\" \"%@%@\" ; open \"%@\"",[[NSBundle mainBundle] pathForResource:@"luna" ofType:@""], theSource, finalPath, [outputTitle stringValue], finalPath];
}

- (IBAction)doConvert:(id)sender{
    NSLog(@"Luna command = %s",[theCommand UTF8String]);
    system([theCommand UTF8String]);
}

- (void) dealloc {
    [super dealloc];
    [image release];
    [outputTitle release];
    [theCommand release];
    [theSource release];
    [finalPath release];
    [theButton release];
}

@end
