//
//  MyNSView.m
//  DragAndDrop_11
//
//  Created by Julius on 12/04/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MyNSView.h"

@implementation MyNSView
@synthesize nsImageObj, imageWell;
@synthesize fileName;

- (id)initWithFrame:(NSRect)frame {
    if (! (self = [super initWithFrame:frame] ) ) {
		NSLog(@"Error: MyNSView initWithFrame");
        return self;
    } // end if
	
	self.nsImageObj = nil;
	
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, nil]];
    
    return self;
}  // end initWithFrame


- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
    
    NSArray *draggedFilenames = [[sender draggingPasteboard] propertyListForType:NSFilenamesPboardType];
    
    if ([[[draggedFilenames objectAtIndex:0] pathExtension] isEqual:@"lua"]) {
        highlight = YES;
    } else {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"goChange2" object:nil];
        highlight = NO;
    }
    
    [self setNeedsDisplay:YES];

    if ((NSDragOperationGeneric & [sender draggingSourceOperationMask]) 
		== NSDragOperationGeneric) {
		
        return NSDragOperationGeneric;
		
    } // end if
	
    // not a drag we can use
	return NSDragOperationNone;	
	
}

- (void)draggingExited:(id <NSDraggingInfo>)sender
{
    highlight = NO;
    [self setNeedsDisplay: YES];
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender {
    return YES;
} // end prepareForDragOperation


- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender {
    //NSPasteboard *zPasteboard = [sender draggingPasteboard];
    
    NSArray *draggedFilenames = [[sender draggingPasteboard] propertyListForType:NSFilenamesPboardType];
       
    if ([[[draggedFilenames objectAtIndex:0] pathExtension] isEqual:@"lua"]) {
        fileName=[[NSURL URLFromPasteboard: [sender draggingPasteboard]] absoluteString];
        NSLog(@"filename = %@",[NSURL URLFromPasteboard: [sender draggingPasteboard]]);
        
        [[NSNotificationCenter defaultCenter] postNotificationName:@"goChange" object:nil];
        [[NSNotificationCenter defaultCenter] postNotificationName:@"updateSource" object:fileName];
        [self setNeedsDisplay:YES];
        return YES;
    } else {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"goChange2" object:nil];
        return NO;
    }
         [self setNeedsDisplay: YES];

	NSLog(@"Error MyNSView performDragOperation");
	return NO;
	
} 
- (void)concludeDragOperation:(id <NSDraggingInfo>)sender {
    highlight = NO;
    [self setNeedsDisplay:YES];
}

- (void)drawRect:(NSRect)dirtyRect {
	if (highlight == YES) {		
		[[NSColor lightGrayColor] set];
        [NSBezierPath setDefaultLineWidth: 5];
        [NSBezierPath strokeRect: dirtyRect];
    } else {
        [[NSColor clearColor] set];
        [NSBezierPath setDefaultLineWidth: 5];
        [NSBezierPath strokeRect: dirtyRect];
    }
//	NSRect zOurBounds = [self bounds];
//    [super drawRect:dirtyRect];
//    [self.nsImageObj compositeToPoint:(zOurBounds.origin) operation:NSCompositeSourceOver];
}

@end
